/***************************************************************************
 *   Copyright (C) 2004 by Adam Skowronski                                 *
 *   tytus@oldfield.org.pl                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EPERIOD_H
#define EPERIOD_H

#include "eindiv.h"
#include "consts.h"

/**
Class for storing information about Periodical events. 
<br>It stores info about end-date, periods, types of periodical event.
@brief Periodic event class
@author Adam Skowronski
*/
class CalendarEventPeriodic : public CalendarEvent
{
public:
    CalendarEventPeriodic();
    ~CalendarEventPeriodic();
    CalendarEventPeriodic(QString text, QDate dStart, QDate dEnd, CalEnums::event_type eType, int period=1, bool *days=NULL, bool autodelete=TRUE, int forgotafter=0);
    bool doesMatch(QDate d);

public:
	bool days[7];					/**< array of days of a week indicators */
	int period;						/**< period of periodical events. \n Value 3 means: 3 weeks, 3 months etc. dependently on eventType */
	CalEnums::event_type eventType;	/**< type of event */
	QDate endDate;					/**< end date of event. After this date the event won't be repeated */
    bool deleteFromFileAfterEnd;	/**< indicates that event will be deleted from periodic.xml file after this dndDate is less than current date minus maxDaysPassedForPeriodic */
	int maxDaysPassedForPeriodic;	/**< how long (days) should periodic event be displayed in a past part calendar */
};



#endif
