/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/



/** \class SettingsWidget
	Class of window of widget of settings*/


/** \name Edit periodic events tab - not finished yet*/
/** @{ */
/** \property    QWidget* SettingsWidget::PeriodicPage;
*/
/** \property    QCheckBox* SettingsWidget::checkBox13_2;
*/
/** \property    QCheckBox* SettingsWidget::checkBox13_3;
*/
/** \property    QCheckBox* SettingsWidget::checkBox13_4;
*/
/** \property    QCheckBox* SettingsWidget::checkBox13_5;
*/
/** \property    QCheckBox* SettingsWidget::checkBox13;
*/
/** \property    QTable* SettingsWidget::PeriodicTable;
*/
/** @} */


/** \name New periodic event tab*/
/** @{ */
/** \property    QComboBox* SettingsWidget::EventType;
Combo box with choise of event type*/
/** \property    QGroupBox* SettingsWidget::EventData;
Group box of event description*/
/** \property    QTextEdit* SettingsWidget::EventInput;
Input field - description of event*/
/** \property    QPushButton* SettingsWidget::Clear;
Button used to clear description*/
/** \property    QPushButton* SettingsWidget::Add;
Button used to create new event*/
/** \property    QGroupBox* SettingsWidget::EventParams;
Group box of event parameters*/
/** \property    QSpinBox* SettingsWidget::number;
number of units set in PeriodType that event has to repeat every*/
/** \property    QComboBox* SettingsWidget::PeriodType;
Combo with period type (unit)*/
/** \property    QCheckBox* SettingsWidget::dayMon;
Checkbox to set event exist on Monday*/
/** \property    QCheckBox* SettingsWidget::dayTue;
Checkbox to set event exist on Tuesday*/
/** \property    QCheckBox* SettingsWidget::dayWed;
Checkbox to set event exist on Wednesday*/
/** \property    QCheckBox* SettingsWidget::dayThu;
Checkbox to set event exist on Thurdsday*/
/** \property    QCheckBox* SettingsWidget::dayFri;
Checkbox to set event exist on Friday*/
/** \property    QCheckBox* SettingsWidget::daySat;
Checkbox to set event exist on Saturday*/
/** \property    QCheckBox* SettingsWidget::daySun;
Checkbox to set event exist on Sunday*/
/** \property    QSpinBox* SettingsWidget::spinWarnDays;
Sets how many days event should be displayed in past calendar*/
/** \property    QDateEdit* SettingsWidget::EditStartDate;
Sets start date of events*/
/** \property    QDateEdit* SettingsWidget::EditEndDate;
Sets end date of events*/
/** \property    QCheckBox* SettingsWidget::checkDeleteAfterEnd;
Sets if event is deleted from periodic events file after end date passes*/

/** @} */


/** \name List of periodic events tab*/
/** @{ */
/** \property    QPushButton* SettingsWidget::DeleteEvent;
Button used to delete selected periodic event*/
/** \property    QLineEdit* SettingsWidget::EndDate;
End date of selected periodic event*/
/** \property    QLineEdit* SettingsWidget::StartDate;
Start date of selected periodic event*/
/** \property    QListBox* SettingsWidget::Events;
List box with list of periodic events*/
/** @} */



/** \name Main buttons */
/** @{ */
/** \property QPushButton* SettingsWidget::OK
	OK button. It accepts all changes done in settings window and closes this window. 
*/
/** \property QPushButton* SettingsWidget::buttonAccept
	Submit button. It accepts all changes done in settings window but doesn't close this window
*/
/** \property    QPushButton* SettingsWidget::buttonCancel
	Cancel button. It discards changes done in settings window and closes this window
*/
/** @} */


/** \name Tabs */
/** @{ */
/** \property    QTabWidget* SettingsWidget::Settings;
	Main tab widget
*/
/** \property    QWidget* SettingsWidget::tab;
	Tab with application settings*/
/** \property    QWidget* SettingsWidget::tab_2;
	Tab with list of periodic events*/
/** \property    QWidget* SettingsWidget::TabPage;
	Tab used to add periodic event*/
/** @} */



/** \name Theme settings*/
/** @{ */
/** \property    QGroupBox* SettingsWidget::groupBox4;
Theme groupbox*/
/** \property    QComboBox* SettingsWidget::comboTheme;
Combo to selected theme which will be used*/
/** \property    QLabel* SettingsWidget::pixmapTheme;
A small place to display screenshot from selected theme*/
/** @} */

/** \name Other settings*/
/** @{ */
/** \property    QCheckBox* SettingsWidget::checkMarkSunday;
Check box to choose if Sundays are displayed with different style*/
/** \property    QCheckBox* SettingsWidget::checkMarkActive;
Check box to choose if active cards (with info window opened) are displayed with different style*/
/** \property    QCheckBox* SettingsWidget::InfoWindowCancellation;
Check box to choose between two behaviours of info window - acceptance of content of this window*/
/** \property    QCheckBox* SettingsWidget::InfoWindowBehavior;
Check box to choose if info windows should be closed if eny other is opened*/
/** \property    QSpinBox* SettingsWidget::spinMaxPastCards;
Spin box to set the maximum width of past calendar*/
/** \property    QSpinBox* SettingsWidget::spinIndividualEventsDelete;
Spin box to set the time which individual events will be deleted from past calendar after */
/** \property    QSlider* SettingsWidget::sliderCurrentWidth;
Slider to set the width of whole application */
/** \property    QLabel* SettingsWidget::labelCurrentWidth;
Displays width of application in percentage of a screen width */
/** @} */

/** \name Event display settings*/
/** @{ */
/** \property    QGroupBox* SettingsWidget::groupBox3_;
Group box of event display settings*/
/** \property    QComboBox* SettingsWidget::comboMonthBitmap;
Combo box to choose bitmap for card with once-a-month event*/
/** \property    QComboBox* SettingsWidget::comboWeekBitmap;
Combo box to choose bitmap for card with once-a-week event*/
/** \property    QComboBox* SettingsWidget::comboYearBitmap;
Combo box to choose bitmap for card with once-a-year event*/
/** \property    QComboBox* SettingsWidget::comboNoEventBitmap;
Combo box to choose bitmap for card with no event*/
/** \property    QComboBox* SettingsWidget::comboIndivBitmap;
Combo box to choose bitmap for card with individual event*/
/** \property    QComboBox* SettingsWidget::comboDayBitmap;
Combo box to choose bitmap for card with once-a-day event*/
/** \property    QComboBox* SettingsWidget::comboAlertBitmap;
Combo box to choose bitmap for card with alert event*/
/** @} */


/** \fn SettingsWidget::clearData()
  Method clears all data on tab "New periodic event" and sets controls into their initial state
*/
void SettingsWidget::clearData()
{
	EditEndDate->setDate(QDate::currentDate());
	EditStartDate->setDate(QDate::currentDate());
	number->setValue(1);
	EventInput->clear();
	dayMon->setChecked(FALSE);
	dayTue->setChecked(FALSE);
	dayWed->setChecked(FALSE);
	dayThu->setChecked(FALSE);
	dayFri->setChecked(FALSE);
	daySat->setChecked(FALSE);
	daySun->setChecked(FALSE);
}


#include <iostream.h>

/** \fn SettingsWidget::changeEventType( int i )
  Method enables and disables adequate control in case of change of event type
  <br><b>Parameters:</b><br><i>i</i> - number of event type.
  */
void SettingsWidget::changeEventType( int i )
{
	//cout << "Change event type to " << i << " \n";
	switch(i)
	{
		case 0:
			dayMon->setEnabled(FALSE);
			dayTue->setEnabled(FALSE);
			dayWed->setEnabled(FALSE);
			dayThu->setEnabled(FALSE);
			dayFri->setEnabled(FALSE);
			daySat->setEnabled(FALSE);
			daySun->setEnabled(FALSE);
			textLabel4->setEnabled(TRUE);
			number->setEnabled(TRUE);
			PeriodType->setEnabled(TRUE);
			break;
		case 1:
			dayMon->setEnabled(TRUE);
			dayTue->setEnabled(TRUE);
			dayWed->setEnabled(TRUE);
			dayThu->setEnabled(TRUE);
			dayFri->setEnabled(TRUE);
			daySat->setEnabled(TRUE);
			daySun->setEnabled(TRUE);
			textLabel4->setEnabled(FALSE);
			number->setEnabled(FALSE);
			PeriodType->setEnabled(FALSE);
			break;
	}
}


void SettingsWidget::UpdateEvents()
{

}



void SettingsWidget::RemoveEvent()
{

}


void SettingsWidget::saveChanges()
{

}

void SettingsWidget::discardChanges()
{

}


void SettingsWidget::changeThemeName( )
{

}

void SettingsWidget::updateData(int i)
{
}

void SettingsWidget::AddEvent( )
{

}




