/***************************************************************************
 *   Copyright (C) 2004 by Adam Skowronski                                 *
 *   tytus@oldfield.org.pl                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THEME_H
#define THEME_H

#include <qfont.h>
#include <qstring.h>
#include <qcolor.h>


/**
This class stores all information about calendar theme
<br>This information is a part of global settings but is stored in a different file and independent of all other settings
@brief Theme object class
@author Adam Skowronski
*/
class CalendarTheme{
public:
    CalendarTheme();

    ~CalendarTheme();
    void setTheme(int HEIGHT, QString filename);

	/** name of theme. could be a name of theme directory in ~/.kalendarz/themes/ or full theme path */
	QString name;
	
	/** font of active card (with opened InfoWidget */
	QFont activeCardFont;
	/** font of normal card */
	QFont cardFont;
	/** font of month name displayed below the cards */
	QFont monthFont;
	/** font of sunday card */
	QFont sundayFont;
	
	/** color of font of normal card */
    QColor cardFontColor;
	/** color of font of month name*/
    QColor monthFontColor;
	/** color of font of active (with opened InfoWidget) card */
	QColor activeCardFontColor;
	/** color of font of sunday card */
	QColor sundayFontColor;

	/** background color of card */
    QColor backgroundCardColor;
	/** background color of application */
    QColor backgroundApplicationColor;
	/** application font color */
	QColor applicationFontColor;
};

#endif
