/***************************************************************************
 *   Copyright (C) 2004 by Adam Skowronski                                 *
 *   tytus@oldfield.org.pl                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; w   /// @todo implement me
ithout even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "wpast.h"
#include <iostream.h>
#include <qfont.h>
#include <qpainter.h>

extern CalendarSettings config;

CalendarWidgetPast::~CalendarWidgetPast()
{

}




/*!
    \fn CalendarWidgetPast::CalendarWidgetPast(QWidget *parent, const char *name, int f, int w, int noOfPastEvents)
	 
 */
CalendarWidgetPast::CalendarWidgetPast(QWidget *parent, const char *name, int f, int w, int noOfPastEvents) 
: CalendarWidget(parent, name, f)
{

	//creation of buttons
	createCalendarCards(&kartki, noOfPastEvents);
	
	//creation of data 
	createCalendarData(&dane, noOfPastEvents);
	
	zero_position = w; //this could change in a future

	
	//setting visible buttons as active
	associateCardsDatas(&kartki, &dane);
}

/*!
    \fn CalendarWidgetPast::shift(int i)
	Moves all CalendarCardWidget windows by i pixels to right of by -i to left
	\param i value of shift.
 */
 void CalendarWidgetPast::shift(int i)
{
	int j;
	CalendarCardWidget *temp;
	
	if (zero_position+i<width)
		if (zero_position==width)
			return;
		else
			{
			i=width-zero_position;
			zero_position=width;
			}
	else
		{
		if (zero_position+i > max_zero_position)
			i=max_zero_position-zero_position;	
		zero_position+=i;
		}
		
	//@todo zoptymalizowac ta funkcje. Chyba nie sa potrzebne te wszystkie rozgazienia.
		
//	cout << "zero_position= " << zero_position << "\n";
	
	if (i>0) //przesuwamy w PRAWO
	{
		for (j=0; j<(int)this->kartki.count(); j++)
			{
				temp=kartki.at(j);
				if(temp->position+i > this->width && temp->infoWindow)
					temp->slotToggled(FALSE);
				temp->moveCalendarCard(i);
			}
	}
	else if (i<0) //przesuwamy w LEWO
	{
		for (j=(int)this->kartki.count()-1; j>=0; j--)
		{
			temp=kartki.at(j);
			if(temp->position+i < -::config.WIDTH && temp->infoWindow)
				temp->slotToggled(FALSE);
			temp->moveCalendarCard(i);
		}
	}
	if(abs(i)>::config.WIDTH)
		{
			for (uint a=0; a < this->kartki.count(); a++)
				kartki.at(a)->repaint();	
		}
	repaint(QRect(0,::config.HEIGHT+1, ::config.kalendarzWidth, ::config.HEIGHT+::config.MONTH_HEIGHT ));
}

/*!
    \fn CalendarWidgetPast::keyPressEvent ( QKeyEvent * e )
	Overloaded member of QWidget::keyPressEvent method.
	Provides shifting of calendar using keyboard.
	\param e system event object
 */
void CalendarWidgetPast::keyPressEvent ( QKeyEvent * e )
{
	QDate date;
	switch(e->key())
	{
		case Qt::Key_Left:	
				shift(-::config.WIDTH);
				break;
		case Qt::Key_Right:	
				shift(::config.WIDTH);
				break;
		case Qt::Key_Up:	
				shift(-7*::config.WIDTH);
				break;
		case Qt::Key_Down:	
				shift(7*::config.WIDTH);
				break;
		case Qt::Key_Prior:	
				//@TODO implement pgup
				cout << "PgUp\n";
				break;
		case Qt::Key_Next:	
				//@TODO implement PgDown
				cout << "PgDown\n";
				break;
		case Qt::Key_Home:
				shift(-zero_position);
 			//	date.currentDate().addDays(-1);
			//	switchToDate(date);
				break;
		default: 
			break;
	}
}

/*!
    \fn CalendarWidgetPast::createCalendarData(QPtrList<CalendarCardData>* lista, int ile)
	Initialisation method
	<br>Creates CalendarCardData objects.
	\param lista pointer to global list of CalendarCardData objects
	\param ile number of new CalendarCardData objects has to be added
 */
void CalendarWidgetPast::createCalendarData(QPtrList<CalendarCardData>* lista, int ile)
{
	int i;
	for (i=1;i<=ile;i++)
	{
		CalendarCardData* dzien;
		dzien = new CalendarCardData(QDate::currentDate().addDays(-i), this);
		lista->append(dzien);
	}
	dispatchEvents(0, ile-1);
}

/*!
    \fn CalendarWidgetPast::paintEvent( QPaintEvent * e)
	Overloaded method of QWidget class. 
		- draws CalendarCardWidget objects
		- draws dates on these objects
		- draws names of months.
	\param e system event object
 */
void CalendarWidgetPast::paintEvent( QPaintEvent * e)
{
	QPainter paint(this);
	paint.setPen(::config.theme.monthFontColor);
	paint.setFont(::config.theme.monthFont);

	CalendarCardWidget *temp;
	int ile=this->kartki.count();
	int i;
	bool t=FALSE;
	
	for (i=0; i<ile; i++)
	{
		temp=this->kartki.at(i);
		if (!temp->bFree && temp->pControl && temp->position>-::config.WIDTH)
		{
			t=TRUE;
			
			paint.drawText(QRect(temp->pos().x()+1, temp->pos().y()+::config.HEIGHT, ::config.WIDTH-2, ::config.MONTH_HEIGHT), AlignCenter, QDate::shortMonthName(temp->pControl->getDate().month()));
		}	
	}
}


/*!
    \fn CalendarWidgetPast::associateCardsDatas(QPtrList<CalendarCardWidget> * kartki, QPtrList<CalendarCardData> * daty)
	Associates CalendarCardData with CalendarCardWidget objects.
	<Br>Sets all necessary data for visible CalendarCardWidget objects.
	\param kartki pointer to list of CalendarCardWidgets object
	\param daty pointer to list of CalendarCardData object
 */
void CalendarWidgetPast::associateCardsDatas(QPtrList<CalendarCardWidget> * kartki, QPtrList<CalendarCardData> * daty)
{
	unsigned int ile=kartki->count();
	for (uint i=0; i<ile; i++)
	{	
		kartki->at(i)->initialiseCardData(zero_position-(i+1)*::config.WIDTH, daty->at(i), i);
		kartki->at(i)->bIsPast=TRUE;
	}
}


/*!
    \fn CalendarWidgetPast::addCardData(QPtrList<CalendarCardData>* lista, int ile)
	Creates \c ile of new CalendarCardData objects. 
	\param lista pointer to global list of CalendarCardData objects
	\param ile number of new CalendarCardData objects has to be added
 */
void CalendarWidgetPast::addCardData(QPtrList<CalendarCardData>* lista, int ile)
{
	int delta_daty;
	int i;
	int ile_dotad=lista->count();

	for (i=1;i<=ile;i++)
	{
		delta_daty=i+ile_dotad;
		CalendarCardData* dzien;
		dzien = new CalendarCardData(QDate::currentDate().addDays(-delta_daty), this);
		lista->append(dzien);
	}
}

/*!
    \fn CalendarWidgetPast::switchToDate(QDate date)
	Method to display imidiately calendar with a specified date
	\param date specified date
 */
void CalendarWidgetPast::switchToDate(QDate date)
{
	//sprawdzenie czy data >= current date
	QDate current_date;
	uint daysTo;
	
	current_date.currentDate();
	
	if (date >= current_date)
	 	date=current_date.addDays(-1);
	
	daysTo=date.daysTo(current_date.addDays(-1));
	
	zero_position=daysTo*::config.WIDTH;
	
	if (dane.count() <= daysTo)
		addCardData(&dane, daysTo-dane.count()+::config.noOfKalWidgets*2);
	
	for (uint i = 0; (int)i < ::config.noOfKalWidgets;i++)
		{
			this->kartki.at(i)->initialiseCardData(i*::config.WIDTH, dane.at(daysTo+i), daysTo+i);
		}

				
	repaint(QRect(0,::config.HEIGHT+1, ::config.kalendarzWidth, ::config.HEIGHT+::config.MONTH_HEIGHT ));	

}


/*!
    \fn CalendarWidgetPast::loadPastEvents(QPtrList<CalendarEventPast>* allI)
	Loads individual events from a file and displays new events on the screen. 
	\param allI list of individual events
 */
void CalendarWidgetPast::loadPastEvents(QPtrList<CalendarEventPast>* allI)
{
	QDate cur=QDate::currentDate();
	for (unsigned int i=0; i< allI->count();i++)
		{
			if(allI->at(i)->startDate<cur)
				this->allIndividualEvents.append(allI->at(i));
		}
	
	this->dispatchEvents(0, this->dane.count()-1);
	
	//teraz trzeba ustawic wszystko
	//ograniczenie iloci kartek - czyli tyle ile jest pastw
	max_zero_position=::config.WIDTH*allIndividualEvents.count();
	/** @todo ograniczenie obszaru - takie jak w ustawieniach, chyba e mniej wynika z iloci kartek*/
 
}

/*!
    \fn CalendarWidgetPast::dispatchEvents(int start, int end)
	Adds individual events to CalendarCardData objects for object from start to end indexes
	\param start start of range of indexes
	\param end end of range of indexes
 */
void CalendarWidgetPast::dispatchEvents(int start, int end)
{
	//CalendarEventPast* temp;
	CalendarCardData* tempControl;
	int a=allIndividualEvents.count();
	
	for(int j=start; j<=end && j<a; j++)
	{
	//tu trzeba odwrocic, zeby chronologicznie sie wyswietlalo
		tempControl=dane.at(j);
		if(tempControl)
		{
			tempControl->date=allIndividualEvents.at(a-j-1)->startDate;
			tempControl->addIndividualEvent(allIndividualEvents.at(a-j-1));
			tempControl->pWidget->updateState(CalEnums::NO_PIXMAP);
			tempControl->pWidget->updateState(tempControl->state);
		}
	}
	
}


/*!
    \fn CalendarWidgetPast::removeIndividualEvent(CalendarEvent* event)
	Removes individual event from a global list of individual events
	\param event individual event has to be removed
 */
void CalendarWidgetPast::removeIndividualEvent(CalendarEvent* event)
{
	allIndividualEvents.removeRef(((CalendarEventPast*)event));
	
	parent->removePastEvent(((CalendarEventPast*)event));
	
}
